
%====================================================================%
%设置ADC采集数据有效位宽
ADC_DATA_WIDTH = 16;
%ADC采集电压范围±VOL_RANGE (V)
VOL_RANGE = 5;
%采样率(Hz)
SAMPLE_RATE = 200000;
%ADC采集电压分辨率 LSB
LSB = VOL_RANGE*2/(2^ADC_DATA_WIDTH);
%====================================================================%
%读取文件数据，转换成波形显示
fileID = fopen('D:\DeskTop\udp.bin');
src_data = fread(fileID);
fclose(fileID);
src_data_hex = src_data;

DATA_NUM = length(src_data_hex);
if(DATA_NUM > 1024*64)
  DATA_NUM = 1024*64;
end

voltage_code = 1:DATA_NUM/2;
voltage_code = voltage_code';
for i=1:1:DATA_NUM/2
  if src_data_hex(2*i-1)+src_data_hex(i*2)*256 > 2^(ADC_DATA_WIDTH-1)
    voltage_code(i) = src_data_hex(2*i-1)+src_data_hex(i*2)*256-2^ADC_DATA_WIDTH;
  else
    voltage_code(i) = src_data_hex(2*i-1)+src_data_hex(i*2)*256;
  end
end

%二进制ADC数据转换为电压值
voltage = voltage_code*LSB - LSB/2;

%ADC采样时间
data_8_1 = voltage(1:16:end,1);
data_num = length(data_8_1);  %计算8组中一组的长度2048 

sample_t = 1:data_num;
sample_t = sample_t';
for i=1:1:data_num
  sample_t(i) = 1000000/SAMPLE_RATE * i;
end

subplot(4,4,1)
plot(sample_t,voltage(1:16:end,1));
axis([0 1000000/SAMPLE_RATE*data_num -VOL_RANGE VOL_RANGE]) 
title('ADC采集电压显示','Fontsize',12,'position',[12000,6])
xlabel('采样时间/(us)','Fontsize',10,'position',[9700,-7])
ylabel('电压/(V)','Fontsize',10)
legend('一一通道')
grid on
 
subplot(4,4,2)
plot(sample_t,voltage(2:16:end,1));
axis([0 1000000/SAMPLE_RATE*data_num -VOL_RANGE VOL_RANGE]) 
xlabel('采样时间/(us)','Fontsize',10,'position',[9700,-7])
ylabel('电压/(V)','Fontsize',10)
legend('二一通道')
grid on

subplot(4,4,3)
plot(sample_t,voltage(3:16:end,1));
axis([0 1000000/SAMPLE_RATE*data_num -VOL_RANGE VOL_RANGE]) 
xlabel('采样时间/(us)','Fontsize',10,'position',[9700,-7])
ylabel('电压/(V)','Fontsize',10)
legend('一二通道')
grid on

subplot(4,4,4)
plot(sample_t,voltage(4:16:end,1));
axis([0 1000000/SAMPLE_RATE*data_num -VOL_RANGE VOL_RANGE]) 
xlabel('采样时间/(us)','Fontsize',10,'position',[9700,-7])
ylabel('电压/(V)','Fontsize',10)
legend('二二通道')
grid on

subplot(4,4,5)
plot(sample_t,voltage(5:16:end,1));
axis([0 1000000/SAMPLE_RATE*data_num -VOL_RANGE VOL_RANGE]) 
xlabel('采样时间/(us)','Fontsize',10,'position',[9700,-7])
ylabel('电压/(V)','Fontsize',10)
legend('一三通道')
grid on

subplot(4,4,6)
plot(sample_t,voltage(6:16:end,1));
axis([0 1000000/SAMPLE_RATE*data_num -VOL_RANGE VOL_RANGE]) 
xlabel('采样时间/(us)','Fontsize',10,'position',[9700,-7])
ylabel('电压/(V)','Fontsize',10)
legend('二三通道')
grid on

subplot(4,4,7)
plot(sample_t,voltage(7:16:end,1));
axis([0 1000000/SAMPLE_RATE*data_num -VOL_RANGE VOL_RANGE]) 
xlabel('采样时间/(us)','Fontsize',10,'position',[9700,-7])
ylabel('电压/(V)','Fontsize',10)
legend('一四通道')
grid on

subplot(4,4,8)
plot(sample_t,voltage(8:16:end,1));
axis([0 1000000/SAMPLE_RATE*data_num -VOL_RANGE VOL_RANGE]) 
xlabel('采样时间/(us)','Fontsize',10,'position',[9700,-7])
ylabel('电压/(V)','Fontsize',10)
legend('二四通道')
grid on

subplot(4,4,9)
plot(sample_t,voltage(9:16:end,1));
axis([0 1000000/SAMPLE_RATE*data_num -VOL_RANGE VOL_RANGE]) 
xlabel('采样时间/(us)','Fontsize',10,'position',[9700,-7])
ylabel('电压/(V)','Fontsize',10)
legend('一五通道')
grid on

subplot(4,4,10)
plot(sample_t,voltage(10:16:end,1));
axis([0 1000000/SAMPLE_RATE*data_num -VOL_RANGE VOL_RANGE]) 
xlabel('采样时间/(us)','Fontsize',10,'position',[9700,-7])
ylabel('电压/(V)','Fontsize',10)
legend('二五通道')
grid on

subplot(4,4,11)
plot(sample_t,voltage(11:16:end,1));
axis([0 1000000/SAMPLE_RATE*data_num -VOL_RANGE VOL_RANGE]) 
xlabel('采样时间/(us)','Fontsize',10,'position',[9700,-7])
ylabel('电压/(V)','Fontsize',10)
legend('一六通道')
grid on

subplot(4,4,12)
plot(sample_t,voltage(12:16:end,1));
axis([0 1000000/SAMPLE_RATE*data_num -VOL_RANGE VOL_RANGE]) 
xlabel('采样时间/(us)','Fontsize',10,'position',[9700,-7])
ylabel('电压/(V)','Fontsize',10)
legend('二六通道')
grid on

subplot(4,4,13)
plot(sample_t,voltage(13:16:end,1));
axis([0 1000000/SAMPLE_RATE*data_num -VOL_RANGE VOL_RANGE]) 
xlabel('采样时间/(us)','Fontsize',10,'position',[9700,-7])
ylabel('电压/(V)','Fontsize',10)
legend('一七通道')
grid on

subplot(4,4,14)
plot(sample_t,voltage(14:16:end,1));
axis([0 1000000/SAMPLE_RATE*data_num -VOL_RANGE VOL_RANGE]) 
xlabel('采样时间/(us)','Fontsize',10,'position',[9700,-7])
ylabel('电压/(V)','Fontsize',10)
legend('二七四通道')
grid on

subplot(4,4,15)
plot(sample_t,voltage(15:16:end,1));
axis([0 1000000/SAMPLE_RATE*data_num -VOL_RANGE VOL_RANGE]) 
xlabel('采样时间/(us)','Fontsize',10,'position',[9700,-7])
ylabel('电压/(V)','Fontsize',10)
legend('一八通道')
grid on

subplot(4,4,16)
plot(sample_t,voltage(16:16:end,1));
axis([0 1000000/SAMPLE_RATE*data_num -VOL_RANGE VOL_RANGE]) 
xlabel('采样时间/(us)','Fontsize',10,'position',[9700,-7])
ylabel('电压/(V)','Fontsize',10)
legend('二八通道')
grid on

%双figure图形
figure
L = data_num/2;
NFFT = 2^nextpow2(L);

Y = fft(voltage(1:16:end,1),NFFT)/L;
Fs = SAMPLE_RATE;
f = Fs/2*linspace(0,1,NFFT/2+1);
len = max(f);
data = 2*abs(Y(1:NFFT/2+1));
subplot(4,4,1)
plot(f,data);
xlabel('Frequency (Hz)')
ylabel('|Y(f)|')
axis([0 len 0 5])
legend('一一通道')

Y = fft(voltage(2:16:end,1),NFFT)/L;
Fs = SAMPLE_RATE;
f = Fs/2*linspace(0,1,NFFT/2+1);
len = max(f);
data = 2*abs(Y(1:NFFT/2+1));
subplot(4,4,2)
plot(f,data);
xlabel('Frequency (Hz)')
ylabel('|Y(f)|')
axis([0 len 0 5])
legend('第二通道')

Y = fft(voltage(3:16:end,1),NFFT)/L;
Fs = SAMPLE_RATE;
f = Fs/2*linspace(0,1,NFFT/2+1);
len = max(f);
data = 2*abs(Y(1:NFFT/2+1));
subplot(4,4,3)
plot(f,data);
xlabel('Frequency (Hz)')
ylabel('|Y(f)|')
axis([0 len 0 5])
legend('一二通道')

Y = fft(voltage(4:16:end,1),NFFT)/L;
Fs = SAMPLE_RATE;
f = Fs/2*linspace(0,1,NFFT/2+1);
len = max(f);
data = 2*abs(Y(1:NFFT/2+1));
subplot(4,4,4)
plot(f,data);
xlabel('Frequency (Hz)')
ylabel('|Y(f)|')
axis([0 len 0 5])
legend('第四通道')

Y = fft(voltage(5:16:end,1),NFFT)/L;
Fs = SAMPLE_RATE;
f = Fs/2*linspace(0,1,NFFT/2+1);
len = max(f);
data = 2*abs(Y(1:NFFT/2+1));
subplot(4,4,5)
plot(f,data);
xlabel('Frequency (Hz)')
ylabel('|Y(f)|')
axis([0 len 0 5])
legend('一三通道')

Y = fft(voltage(6:16:end,1),NFFT)/L;
Fs = SAMPLE_RATE;
f = Fs/2*linspace(0,1,NFFT/2+1);
len = max(f);
data = 2*abs(Y(1:NFFT/2+1));
subplot(4,4,6)
plot(f,data);
xlabel('Frequency (Hz)')
ylabel('|Y(f)|')
axis([0 len 0 5])
legend('第六通道')

Y = fft(voltage(7:16:end,1),NFFT)/L;
Fs = SAMPLE_RATE;
f = Fs/2*linspace(0,1,NFFT/2+1);
len = max(f);
data = 2*abs(Y(1:NFFT/2+1));
subplot(4,4,7)
plot(f,data);
xlabel('Frequency (Hz)')
ylabel('|Y(f)|')
axis([0 len 0 5])
legend('第七通道')

Y = fft(voltage(8:16:end,1),NFFT)/L;
Fs = SAMPLE_RATE;
f = Fs/2*linspace(0,1,NFFT/2+1);
len = max(f);
data = 2*abs(Y(1:NFFT/2+1));
subplot(4,4,8)
plot(f,data);
xlabel('Frequency (Hz)')
ylabel('|Y(f)|')
axis([0 len 0 5])
legend('第八通道')

Y = fft(voltage(9:16:end,1),NFFT)/L;
Fs = SAMPLE_RATE;
f = Fs/2*linspace(0,1,NFFT/2+1);
len = max(f);
data = 2*abs(Y(1:NFFT/2+1));
subplot(4,4,9)
plot(f,data);
xlabel('Frequency (Hz)')
ylabel('|Y(f)|')
axis([0 len 0 5])
legend('第九通道')

Y = fft(voltage(10:16:end,1),NFFT)/L;
Fs = SAMPLE_RATE;
f = Fs/2*linspace(0,1,NFFT/2+1);
len = max(f);
data = 2*abs(Y(1:NFFT/2+1));
subplot(4,4,10)
plot(f,data);
xlabel('Frequency (Hz)')
ylabel('|Y(f)|')
axis([0 len 0 5])
legend('第十通道')

Y = fft(voltage(11:16:end,1),NFFT)/L;
Fs = SAMPLE_RATE;
f = Fs/2*linspace(0,1,NFFT/2+1);
len = max(f);
data = 2*abs(Y(1:NFFT/2+1));
subplot(4,4,11)
plot(f,data);
xlabel('Frequency (Hz)')
ylabel('|Y(f)|')
axis([0 len 0 5])
legend('第十一通道')

Y = fft(voltage(12:16:end,1),NFFT)/L;
Fs = SAMPLE_RATE;
f = Fs/2*linspace(0,1,NFFT/2+1);
len = max(f);
data = 2*abs(Y(1:NFFT/2+1));
subplot(4,4,12)
plot(f,data);
xlabel('Frequency (Hz)')
ylabel('|Y(f)|')
axis([0 len 0 5])
legend('二一通道')

Y = fft(voltage(13:16:end,1),NFFT)/L;
Fs = SAMPLE_RATE;
f = Fs/2*linspace(0,1,NFFT/2+1);
len = max(f);
data = 2*abs(Y(1:NFFT/2+1));
subplot(4,4,13)
plot(f,data);
xlabel('Frequency (Hz)')
ylabel('|Y(f)|')
axis([0 len 0 5])
legend('第十三通道')

Y = fft(voltage(14:16:end,1),NFFT)/L;
Fs = SAMPLE_RATE;
f = Fs/2*linspace(0,1,NFFT/2+1);
len = max(f);
data = 2*abs(Y(1:NFFT/2+1));
subplot(4,4,14)
plot(f,data);
xlabel('Frequency (Hz)')
ylabel('|Y(f)|')
axis([0 len 0 5])
legend('第十四通道')

Y = fft(voltage(15:16:end,1),NFFT)/L;
Fs = SAMPLE_RATE;
f = Fs/2*linspace(0,1,NFFT/2+1);
len = max(f);
data = 2*abs(Y(1:NFFT/2+1));
subplot(4,4,15)
plot(f,data);
xlabel('Frequency (Hz)')
ylabel('|Y(f)|')
axis([0 len 0 5])
legend('第十五通道')

Y = fft(voltage(16:16:end,1),NFFT)/L;
Fs = SAMPLE_RATE;
f = Fs/2*linspace(0,1,NFFT/2+1);
len = max(f);
data = 2*abs(Y(1:NFFT/2+1));
subplot(4,4,16)
plot(f,data);
xlabel('Frequency (Hz)')
ylabel('|Y(f)|')
axis([0 len 0 5])
legend('第十六通道')


